<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               ref="crud"
               @row-del="rowDel"
               v-model="form"
               :permission="permissionList"
               @row-update="rowUpdate"
               @row-save="rowSave"
               :before-open="beforeOpen"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.notice_delete"
                   @click="handleDelete">刪 除
        </el-button>
      </template>
      <template slot-scope="{row}"
                slot="category">
        <el-tag>{{row.categoryName}}</el-tag>
      </template>

      <template slot-scope="{row}" slot="menu">
        <el-button size="small" class="el-button--text" v-if="userInfo.user_id == row.createUser && row.type != 0" @click="$refs.crud.rowEdit(row, index)"><i class="el-icon-edit"></i> 編 輯</el-button>
        <el-button size="small" class="el-button--text" v-if="userInfo.user_id == row.createUser && row.type != 0" @click="$refs.crud.rowDel(row, index)"><i class="el-icon-delete"></i> 刪 除</el-button>
      </template>

    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, remove, update, add, getNotice} from "@/api/desk/notice";
  import {mapGetters} from "vuex";
  import {getDeptTree, getTree} from "@/api/system/dept";
  import {getRoleTree} from "@/api/system/role";
  import website from '@/config/website';
  import {getUsersByDeptIdsRoleIds} from "../../api/user";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height: 'auto',
          calcHeight: 30,
          dialogWidth: 950,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          editBtn: false,
          delBtn: false,
          selection: true,
          // excelBtn: true,
          dialogClickModal: false,
          column: [
            {
              label: "通知標題",
              prop: "title",
              span: 24,
              row: true,
              search: true,
              rules: [{
                required: true,
                message: "請輸入通知標題",
                trigger: "blur"
              }]
            },
            /*{
              label: "通知類型",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=notice",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              slot: true,
              prop: "category",
              search: true,
              rules: [{
                required: true,
                message: "請輸入通知類型",
                trigger: "blur"
              }]
            },
            {
              label: "通知時間",
              prop: "releaseTimeRange",
              type: "datetime",
              format: "yyyy-MM-dd HH:mm:ss",
              valueFormat: "yyyy-MM-dd HH:mm:ss",
              searchRange:true,
              hide: true,
              addDisplay: false,
              editDisplay: false,
              viewDisplay: false,
              search: true,
              rules: [{
                required: true,
                message: "請輸入通知時間",
                trigger: "blur"
              }]
            },
            {
              label: "通知日期",
              prop: "releaseTime",
              type: "date",
              format: "yyyy-MM-dd HH:mm:ss",
              valueFormat: "yyyy-MM-dd HH:mm:ss",
              rules: [{
                required: true,
                message: "請輸入通知日期",
                trigger: "click"
              }]
            },*/
            {
              label: "表單名稱",
              prop: "businessType",
              type: "select",
              addDisplay: false,
              editDisplay: false,
              disabled: true,
              dicData: [
                {
                  label: "網點鎖匙/密碼/實物交接登記表", value: "keypwd"
                },
                {
                  label: "業務印章交接登記表", value: "sealhandover"
                },
                {
                  label: "網點出納主管及專管員崗位變更記錄表", value: "postchange"
                },
                {
                  label: "查庫流水帳記錄表", value: "checkwarehouse"
                },
                {
                  label: "核對記錄表（每日）", value: "checklist_day"
                },
                {
                  label: "核對記錄表（每週）", value: "checklist_week"
                },
                {
                  label: "核對記錄表（每月）", value: "checklist_month"
                },
                {
                  label: "櫃員尾箱檢查流水帳記錄表", value: "tellertrunk"
                },
                {
                  label: "使用及出入庫登記表", value: "goodsuse"
                },
                {
                  label: "新開戶退件登記表", value: "returns"
                },
                {
                  label: "自助設備吞卡資料", value: "cardswallow"
                },
                {
                  label: "信息發佈", value: "message"
                },
              ],
              rules: [{
                required: false,
                message: "請輸入業務流程",
                trigger: "blur"
              }]
            },
            {
              label: "通知方式",
              prop: "type",
              type: "radio",
              value: '1',
              dicData: [{
                label: '系統',
                disabled: true,
                value: '0'
              },{
                label: '機構',
                value: '1'
              }, {
                label: '廣播',
                value: '2'
              }, {
                label: '個人',
                value: '3'
              }],
              change: ({value}) => {
                if (!value) return;
                let $deptId = this.findObject(this.option.column, "deptId");
                let $targetIds = this.findObject(this.option.column, "targetIds");
                if (value == '1'){
                  // $deptId.multiple = false;
                  $deptId.checkStrictly = true;
                }else{
                  // $deptId.multiple = true;
                  $deptId.checkStrictly = false;
                }
                $targetIds.rules[0].required = value == "3";
              },
            },
            {
              label: "查閱部門",
              prop: "deptName",
              display: false
            },
            {
              label: "查閱部門",
              prop: "deptId",
              type: "tree",
              multiple: true,
              hide: true,
              dataType: "string",
              dicData: [],
              props: {
                label: "title"
              },
              checkStrictly: false,
              change: ({value}) => {
                if (!value) return;
                getUsersByDeptIdsRoleIds(value, this.form.roleId).then(res => {
                  const data = res.data.data;
                  if (data && data.length > 0){
                    this.findObject(this.option.column, "targetIds").dicData = data;
                  }
                });
              },
              rules: [{
                required: true,
                message: "請選擇查閱部門",
                trigger: "click"
              }]
            },
            {
              label: "查閱角色",
              prop: "roleName",
              display: false
            },
            {
              label: "查閱角色",
              prop: "roleId",
              hide: true,
              // search: true,
              multiple: true,
              type: "tree",
              dataType: "string",
              dicData: [],
              props: {
                label: "title"
              },
              checkStrictly: false,
              // slot: true,
              change: ({value}) => {
                if (!value) return;
                getUsersByDeptIdsRoleIds(this.form.deptId, value).then(res => {
                  const data = res.data.data;
                  if (data && data.length > 0){
                    this.findObject(this.option.column, "targetIds").dicData = data;
                  }
                });
              },
              rules: [{
                required: false,
                message: "請選擇查閱角色",
                trigger: "click"
              }]
            },
            {
              label: "查閱人員",
              prop: "targetNames",
              display: false
            },
            {
              label: "查閱人員",
              prop: "targetIds",
              type: "select",
              multiple: true,
              hide: true,
              dataType: "string",
              dicData: [],
              props: {
                label: "name",
                value: "id"
              },
              rules: [{
                required: false,
                message: "請選擇查閱人員",
                trigger: "click"
              }]
            },
            {
              label: "通知內容",
              prop: "content",
              component: 'AvueUeditor',
              options: {
                action: '/api/blade-resource/oss/endpoint/put-file',
                props: {
                  res: "data",
                  url: "link",
                }
              },
              hide: true,
              minRows: 6,
              span: 24,
            },
            {
              label: "發佈時間",
              prop: "createTime",
              display: false
            }

          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission", "userInfo"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.notice_add, false),
          viewBtn: this.vaildData(this.permission.notice_view, false),
          delBtn: this.vaildData(this.permission.notice_delete, false),
          editBtn: this.vaildData(this.permission.notice_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    mounted() {
      getDeptTree().then(res => {
        const column = this.findObject(this.option.column, "deptId");
        let treeData = getTree(res.data.data, this.userInfo.dept_id);
        column.dicData = treeData;
      });
      getRoleTree(website.tenantId).then(res => {
        const column = this.findObject(this.option.column, "roleId");
        column.dicData = res.data.data;
      });
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          window.console.log(error);
          loading();
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          window.console.log(error);
          loading();
        });
      },
      rowDel(row) {
        this.$confirm("確定將選擇數據刪除?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("請選擇至少一條數據");
          return;
        }
        this.$confirm("確定將選擇數據刪除?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {

        if (["edit", "view"].includes(type)) {
          getNotice(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      currentChange(currentPage) {
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize) {
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        const {releaseTimeRange} = this.query;
        let values = {
          ...params,
        };
        if (releaseTimeRange) {
          values = {
            ...params,
            releaseTime_datege: releaseTimeRange[0],
            releaseTime_datelt: releaseTimeRange[1],
            ...this.query
          };
          values.releaseTimeRange = null;
        }
        this.loading = true;
        getList(page.currentPage, page.pageSize, values).then(res => {
          const data = res.data.data;
          this.page.total = data.total;

          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
